/* 
** Generic frambuffer support
**
** Copyright (C) 1997    Jason McMullan, [jmcc@cs.cmu.edu]
** Copyright (C) 1995-97 Andreas Beck - becka@sunserver1.rz.uni-duesseldorf.de
** Copyright (C) 1995-97 Steffen Seeger, [seeger@physik.tu-chemnitz.de]
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define	MAINTAINER	"Jason McMullan, [jmcc@cs.cmu.edu]"
#define	DRIVER_VERSION	"0.01"

/*\
|*|     KGI includes
\*/

#include <ggi/module.h>
#include <ggi/ggi_commands.h>

#include "suggest.inc"

/*
**	KGI module interface
*/

int kgim_graphics_init(struct kgi_card *card, struct kgi_display *dpy)
{
	/* !!! We should really do something here !!! */
	TRACE(printk("generic linear framebuffer Graphics Driver loaded\n"));
	return EOK;
}

void kgim_graphics_done(struct kgi_display *dpy)
{
	TRACE(printk("generic linear framebuffer Graphics Driver removed\n"));
}

int kgim_graphics_check_mode (struct kgi_display *dpy, struct kgi_mode *mode,
			    enum kgi_tm_cmd cmd)
{
	/* !!! Should we check for accel-friendly dimensions here ??? */
	return EOK;

}

void kgim_graphics_set_mode (struct kgi_display *dpy, struct kgi_mode *mode)
{
	/* !!! We should set up the accel here !!! */
	return;
}


int kgim_graphics_command (struct kgi_graphic *gr, ggi_uint cmd,ggi_uint arg)
{ 
	ggi_suggest *sugg;
	const char *name;

	switch (cmd) {

	case GRAPHICS_GETSUGGEST:
		sugg=(ggi_suggest *)(gr->io_buf);
		gr->io_res=gr->io_buf;

		if (sugg->id<0 || sugg->id > 1)
			return -E(GRAPHICS,BOGUS);

		if (sugg->id==1) { /* Generic RAMDAC support */

			name = sugg_ramdac[gr->dev.mode.graphtype];
			strcpy(sugg->name, name);
			sugg->args[0] = 0;
			sugg->id = 0;
			return EOK;
		}
		name=sugg_default[gr->dev.mode.graphtype];
		strcpy(sugg->name,name);
		sugg->args[0] = 0;
		sugg->id = 1;	/* Next is RAMDAC.. */
		return EOK;

	default:
		break;
	}
			
	return -E(GRAPHICS,NOSUP_ALWAYS_MMAP);
}
