/* ---------------------------------------------------------------------------
* Chips & Technologies chipset driver
* --------------------------------------------------------------------------
*
* Copyright (C) 1997 Stephan Meyer <Stephan.Meyer@pobox.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
* ---------------------------------------------------------------------------
*
* This code was derived from the following sources of information:
* [1] the technical specifications available from www.chips.com
* [2] Xfree86 Chips driver
* [3] svgalib 1.2.11 Chips driver
*
* Many thanks go to David Bateman <dbateman@ee.uts.edu.au> et al.
*/

#ifndef __CHIPS_H
#define __CHIPS_H

#define CHIPS_65545		0
#define CHIPS_65548		1
#define CHIPS_65550		2
#define CHIPS_65554		3

#define CHIPS_CRTC_COUNT	24
#define CHIPS_ATC_COUNT		21
#define CHIPS_GRAPHICS_COUNT	9
#define CHIPS_SEQUENCER_COUNT	5
#define CHIPS_EXTENSION_COUNT	128
#define CHIPS_VCLOCK_COUNT	3

typedef struct {
	uint8	miscoutput;
	uint8	crtc[CHIPS_CRTC_COUNT];
	uint8	atc[CHIPS_ATC_COUNT];
	uint8	graphics[CHIPS_ATC_COUNT];
	uint8	sequencer[CHIPS_SEQUENCER_COUNT];
	uint8	extension[CHIPS_EXTENSION_COUNT];
	uint8	vclock[CHIPS_VCLOCK_COUNT];
} ChipsRegs;

extern void chips_calcclock(int clock, ChipsRegs *regs);

#endif
