/* --------------------------------------------------------------------------
**	S3 Trio/ViRGE internal DAC/Clock Synth interface
** --------------------------------------------------------------------------
**
**	Copyright (C) 1997		Steffen Seeger
**
**	This program is free software; you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation; either version 2, or (at your option)
**	any later version.
**
**	You should have received a copy of the GNU General Public License
**	along with this program; see the file COPYING.  If not, write to
**	the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
** ---------------------------------------------------------------------------
*/

#ifndef	_S3_idac_h
#define	_S3_idac_h

/*	Virtual clock chip registers
**	These are to be used with the CLK_in/out functions provided by
**	the Trio/ViRGE chipset drivers only.
*/

#define	CLK_CLOCKSELECT	0
	#define	CLK0_25MHZ	0x00
	#define	CLK0_28MHZ	0x01
	#define	CLK0_PLL	0x03

#define	CLK_MCLK_LOW	1		/* maps directly to SR10	*/
	#define	CLK1_MCLK_N_MASK	0x1f
	#define	CLK1_MCLK_R_MASK	0x60

#define	CLK_MCLK_HIGH	2		/* maps directly to SR11	*/
	#define	CLK2_MCLK_M_MASK	0x7F

#define	CLK_DCLK_LOW	3		/* maps direclty to SR12	*/
	#define	CLK3_DCLK_N_MASK	0x1f
	#define	CLK3_DCLK_R_MASK	0x60

#define	CLK_DCLK_HIGK	4		/* maps directly to SR13	*/
	#define	CLK4_DCLK_M_MASK	0x7F

#define	CLK_CLKSYN_CTRL1	5	/* maps directly to SR14	*/
	#define	CLK5_DCLK_PD	0x01	/* power down DCLK PLL		*/
	#define	CLK5_MCLK_PD	0x02	/* power down MCLK PLL		*/
	#define	CLK5_ENB_CNT	0x04	/* enable clock syn counters	*/
	#define	CLK5_M_TEST	0x08	/* MCLK test			*/
	#define	CLK5_CLR_CNT	0x10	/* clear clock syn counters	*/
	#define	CLK5_P146_SEL	0x20	/* select pin 146 function	*/
	#define	CLK5_EXT_MCLK	0x40	/* select external MCLK		*/
	#define	CLK5_EXT_DCLK	0x80	/* select external DCLK		*/

#define	CLK_CLKSYN_CTRL2	6	/* maps directly to SR15	*/
	#define	CLK6_LOAD_MCLK	0x01	/* autoload MCLK values		*/
	#define	CLK6_LOAD_DCLK	0x02	/* autoload DCLK values		*/
	#define	CLK6_MCLK_OUT	0x04	/* pin 147 is MCLK output	*/
	#define	CLK6_DCLK_OUT	0x08	/* pin 148 function control	*/
	#define	CLK6_DCLK_DIV2	0x10	/* divide DCLK by 2		*/
	#define	CLK6_LOAD_CLKS	0x20	/* load DCLK and MCLK values	*/
	#define	CLK6_INV_DCLK	0x40	/* invert DCLK			*/
	#define	CLK6_2CYC_MEMWR	0x80	/* 2 cycle memory writes	*/

	/*	only these bits can be controled by the clock driver.
	*/
	#define	CLK6_CLOCK_MASK	0x23

#endif	/* #ifdef _S3_idac_h */
