/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de
   Copyright (C) 1997 Jason McMullan - jmcc@cs.cmu.edu

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifdef _AIX
#include <sys/ioctl.h>
#include <sys/types.h>
#include <unistd.h>
#endif

#include "ggi-dl.h"
#include <ggi/ggi_commands.h>

#define SPEED_TRESHOLD 15

extern struct ggi_visual_op2d fallback_op2d;

/**********************
 * Drawline via IOCTL *
 **********************/

int GGIdrawline(ggi_visual *vis,int x1,int y1,int x2,int y2)
{
	int RC;
	int result;

	if ( ((abs(x2-x1) & ~SPEED_TRESHOLD) == 0) &&
	     ((abs(y2-y1) & ~SPEED_TRESHOLD) == 0) ) 
		return fallback_op2d.drawline(vis,x1,y1,x2,y2);

	if ((RC=ioctl(vis->fd,(int)GRAPHICS_DRAWLINE,&x1))<0) 
	{ 
		result = (RC == -1) ? errno : -RC;
		if ((result&NOSUP_MASK)==NOSUP)
		{	switch(result&AVE_MASK)
			{ case AVE_NOW:
				return fallback_op2d.drawline(vis,x1,y1,x2,y2);
			  default:
				return (vis->op2d->drawline=fallback_op2d.drawline)(vis,x1,y1,x2,y2);
			}
		}
	}

	return RC;
}

