/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de
   Copyright (C) 1997 Jason McMullan - jmcc@cs.cmu.edu

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <string.h>

#include "ggi-dl.h"

/*************************************/
/* fill (erase) the (virtual) screen */
/*************************************/

int GGIfillscreen(ggi_visual *vis)
{
	if (VIS_GC(vis)->cliptl.x==0 &&
	    VIS_GC(vis)->cliptl.y==0 &&
	    VIS_GC(vis)->clipbr.x==VIS_FB_WIDTH(vis) &&
	    VIS_GC(vis)->clipbr.y==VIS_FB_HEIGHT(vis))
	  {
		  uint16 *fb=(uint16 *)VIS_FB_LINEAR(vis);
		  int i,len=VIS_FB_WIDTH(vis)*VIS_FB_HEIGHT(vis);

		  for (i=0;i<len;i++)
			  *(fb++)=VIS_GC_FGCOLOR(vis);
	  }
	else
		ggiDrawBox(vis, VIS_GC(vis)->cliptl.x,VIS_GC(vis)->cliptl.y,
			   VIS_GC(vis)->clipbr.x,VIS_GC(vis)->clipbr.y);
	return 0;
}

