/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de
   Copyright (C) 1997 Jason McMullan - jmcc@cs.cmu.edu

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>

#include "ggi-dl.h"
#include <ggi/ggi_commands.h>

int GGIdbinit(ggi_visual *visual)
{
	ggi_directbuffer *db;

	if ( NULL== (db=malloc(sizeof(ggi_directbuffer))) ) return -ENOMEM;
       	
       	db->app_private=db->lib_private=db->drv_private=NULL;
       	db->layout=blPixelLinearBuffer;
       	db->buffer.pixellinearbuffer.read=
       	db->buffer.pixellinearbuffer.write=VIS_FB_LINEAR(visual);
       	db->buffer.pixellinearbuffer.page_size=0; /* FIXME. Find that out. */
       	db->buffer.pixellinearbuffer.access=2|4|8;
       	db->buffer.pixellinearbuffer.align=2;
       	db->buffer.pixellinearbuffer.swap=0;
       	db->buffer.pixellinearbuffer.write_mask=0xffffffff;
       	db->buffer.pixellinearbuffer.bpp=16;
       	db->buffer.pixellinearbuffer.stride=VIS_FB_WIDTH(visual)*2;
       	db->buffer.pixellinearbuffer.origin.x=
       	db->buffer.pixellinearbuffer.origin.y=0;
       	db->buffer.pixellinearbuffer.size.x=VIS_FB_WIDTH(visual);
       	db->buffer.pixellinearbuffer.size.y=VIS_FB_HEIGHT(visual);
       	strcpy(db->buffer.pixellinearbuffer.colorstring,"RGB");
       	db->buffer.pixellinearbuffer.setup=sp16a16r5g6b5;
	/* numpad and PADs missing ! FIXME ! */

       	db->next=VIS_DB(visual);
	VIS_DB(visual)=db;

	return 0;	/* Always succeed */
}

