/* 
   Graphics library for GGI. Horizontal lines.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <string.h>

#include "ggi-dl.h"

/**********************************/
/* draw/get/put a horizontal line */
/**********************************/

int GGIdrawhline(ggi_visual *vis,int x,int y,int w)
{
	for (;w>0;w--,x++)
		ggiDrawPixel(vis,x,y);
	return 0;
}

int _GGIdrawhline(ggi_visual *vis,int x,int y,int w)
{
	for (;w>0;w--,x++)
		_ggiDrawPixel(vis,x,y);
	return 0;
}

int GGIputhline(ggi_visual *vis,int x,int y,int w,void *buffer)
{
	int rowadd = (VIS_FB_BPP(vis)+7)/8/sizeof(uint8);

	for (;w>0;w--,x++)
	{
		ggiPutPixel(vis,x,y,*((int *)buffer));	/* OUCH ! FIXME ! */
		buffer=(uint8 *)buffer+rowadd;
	}
	return 0;
}

int GGIgethline(ggi_visual *vis,int x,int y,int w,void *buffer)
{
	int rowadd = (VIS_FB_BPP(vis)+7)/8/sizeof(uint8);

	for (;w>0;w--,x++)
	{
		ggiGetPixel(vis,x,y,buffer);
		buffer=(uint8 *)buffer+rowadd;
	}
	return 0;
}
