#undef DEBUG
#ifdef DEBUG
#define DEBUG_LEVEL 2
#endif
#include "evstack.h"

#define CLASSNAME "devecho"

static ev_id devecho_id;
static int  devecho_use=0;

static int  devecho_open(evstack *blank);
static int  devecho_close(evstack *slf);
static void devecho_handler(evstack *slf,ggi_event *ev,int *left);
static int  devecho_uses(evstack *slf);

static evstack_operations devecho_ops={
	devecho_open,
	devecho_close,
	devecho_handler,
	devecho_uses,
	NULL,
	NULL
};

static int devecho_open(evstack *blank)
{
	sprintf(blank->name,"devecho v1.0 (instance %.4x)",
		blank->id&EV_ID_MASK);

	blank->maintainer="becka@sunserver1.rz.uni-duesseldorf.de";

	blank->private=NULL;

	devecho_use++;

	return 0;
}

static int devecho_close(evstack *slf)
{
	devecho_use--;

	return 0;
}

	
/* A sample tty module
 */
static void devecho_handler(evstack *slf,ggi_event *ev,int *left)
{ 
	ggi_cmd_event *evdat;
	char outchar[256];

	for(;ev->size;ev=ev_evpage_next(ev))       /* Loop through all events in page */
	{
		/* We are interested in sending cooked data to the user. */
		switch(ev->any.type)
		{ 
		  case evCommand:
		  	evdat=(ggi_cmd_event *)ev;
		  	switch(evdat->code)
		  	{
		  	  case CmdTtyInWriteChar:
				ev_consume(ev);
				DEBUG1("got event %x.\n",evdat->code);
				{ DataTtyWriteChar *dt=(DataTtyWriteChar *)evdat->data;
				  DEBUG1("%d chars :%*.*s.\n",dt->size
				  	  ,dt->size,dt->size,dt->data);
				  /* now we would send it to usermode */

				  /* For testing purposes we simply echo it. */
				  build_cmd_event(outchar,CmdTtyOutWriteChar,dt,dt->size+sizeof(dt->size));

				  DEBUG1("sending echo command '%c'.\n",dt->data[0]);

	                          TRACE1({ int x;
	                          for(x=0;x<20;x++)
        	                  	printk("%2x ",*(((unsigned char *)(outchar))+x));
	                          printk(")\n"); }
	                          );
                                                                                                  
				  ev_evpage_add(ev,left,(ggi_event *)&outchar);
				} break;
		  	  default:
		  	  	break;
			}
			break;
		  default: 
		  	break;
		}
	}
}

static int devecho_uses(evstack *stack)
{
	return devecho_use;
}

#ifdef MODULE
#define init_devecho init_module
#endif

int init_devecho(void)
{ 
#if 0
	if (register_chrdev(major,CLASSNAME,&event_fops)) {
		printk(__FILE__": unable to get major %d\n", major);
		return -EIO;
	}
#endif

	devecho_id=ev_register_class(CLASSNAME,&devecho_ops);
	printk("Registered %s.\n",CLASSNAME);

	return 0;
}

#ifdef MODULE
void cleanup_module(void)
{ 
#if 0
	unregister_chrdev(major,CLASSNAME);
#endif
	ev_unregister_class(devecho_id);
	printk("Unregistered %s.\n",CLASSNAME);
}
#endif
