/* $Id: TIvisual.h,v 1.3 1998/02/17 21:22:25 vogler Exp $
 *
 * Copyright 1998 MenTaLboY - mentalboy@geocities.com
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdlib.h>
#include <stdio.h>
#define __cplusplus
#include <ggi/system.h>
#undef __cplusplus
#include "curses.h"
#include "ggi-dl.h"

struct TIhooks {
	SCREEN *scr;
	FILE *f_in, *f_out;
	int f_private;
	struct { int x, y; } origin;
	int splitline;
	int virgin;
	chtype color16_table[256];
	chtype charmap[256];
};

#ifdef USE_THREADS
	#warning ncurses MUST have been compiled with -D_REENTRANT
	#include <pthread.h>
	extern pthread_mutex_t _tivisual_ncurses_mutex;
	#define lock_ncurses() pthread_mutex_lock(&_tivisual_ncurses_mutex)
	#define unlock_ncurses() pthread_mutex_unlock(&_tivisual_ncurses_mutex)
#else
	#define lock_ncurses()
	#define unlock_ncurses()
#endif

extern int paint_ncurses_window(ggi_visual *, WINDOW *, int, int);
