/* 
   Mystique userspace acceleration library

   Copyright (C) 1997 Matthias Grimrath - m.grimrath@tu-bs.de

   Anyone is welcome to improve this lib and send diffs to me.
 
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <string.h>

#include "ggi-dl.h"
#include "mystique-8-15-16-32.h"

/*************************************/
/* fill (erase) the (virtual) screen */
/*************************************/

int GGIfillscreen(ggi_visual *vis)
{
	DPRINT("fillscreen: fg=0x%.8x, width=%d, height=%d\n",
	       VIS_GC_FGCOLOR(vis),VIS_FB_WIDTH(vis),VIS_FB_HEIGHT(vis));

	ACC_ADDDATA(DMA_FXBNDRY, (VIS_FB_WIDTH(vis) << 16) | 0);
	ACC_ADDDATA(DMA_YDSTLEN, (0 << 16) | VIS_FB_HEIGHT(vis));
	ACC_ADDDATA(DMA_FCOL, VIS_GC_FGCOLOR(vis));
	ACC_ADDDATA(DMA_DWGCTL | DMA_GO, TRAP | __blkmode | SOLID | ARZERO | 
		    SGNZERO | SHFTZERO | BOP_COPY | BLTMOD_BMONOLEF);
	
	return SYNC_FLUSH(vis);
}
