/* 
 *  line drawing
 *
 *  Copyright (C) 1998 Thomas Tanner. See CREDITS for details.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "lib.h"
#include "util.h"

/*----------------------------------------------------------------------*/

static void	line(ggi_visual_t vis, int x1, int y1, int x2, int y2)
{
	void 	(*drawPixel)(ggi_visual_t, int, int)
		= GGI2D_FUNC(vis)->drawPixel;

#define HLINE(x1, x2, y)	GGI2D_FUNC(vis)->hLine(vis, x1, x2, y)
#define VLINE(x, y1, y2)	GGI2D_FUNC(vis)->vLine(vis, x, y1, y2)
#define PLOT(x, y)		drawPixel(vis, x, y)

#include "template/line.h"
}

static void	line_st(ggi_visual_t vis, int x1, int y1, int x2, int y2)
{
}

static void	line_aa(ggi_visual_t vis, int x1, int y1, int x2, int y2)
{
	void 	(*drawPixel)(ggi_visual_t, int, int)
		= GGI2D_FUNC(vis)->drawPixel;
	void 	(*drawPixelA)(ggi_visual_t, int, int, ggi_alpha) 
		= GGI2D_FUNC(vis)->drawPixelA;

#define HLINE(x1, x2, y)	GGI2D_FUNC(vis)->hLine(vis, x1, x2, y)
#define VLINE(x, y1, y2)	GGI2D_FUNC(vis)->vLine(vis, x, y1, y2)
#define PLOT(x, y)		drawPixel(vis, x, y)
#define PLOTA(x, y, alpha)	drawPixelA(vis, x, y, alpha)
#define ANTIALIAS

#include "template/line.h"
}

static void	line_st_aa(ggi_visual_t vis, int x1, int y1, int x2, int y2)
{
}

void	(*GGINAME(line)[4])(ggi_visual_t vis, int x1, int y1, int x2, int y2) =
{
	line,
	line_st,
	line_aa,
	line_st_aa
};

/*----------------------------------------------------------------------*/
