/* 
 *  GGI Utility library
 *
 *  Copyright (C) 1998 Uwe Maurer - uwe_maurer@t-online.de
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <internal.h>
#include <string.h>

int	_ggu_offset;

static int load(ggi_visual_t vis,const char *lib,const char *opt)
{
	ggu_extension_t *e;
	int bpp;

	e=GGU(vis);

	if (strncmp(lib,"display",7)==0)
	{ 
		if (e->init==0) {
			e->adjust=GGU_TRUE;
		}
		e->init=1;
	}
	else
	if (strcmp(lib,"generic-stubs")==0)
	{
		e->db=NULL;
		bpp=gguBPP(GGU_GT(vis));
		e->palstart=0;
		e->steps=32;

		if (bpp<=8) {
			e->pallen=1<<bpp;
		}
		else {
			e->pallen=0;
		}
	}
	
	return 0;
}
static int unload(ggi_visual_t vis,const char *lib)
{
	return 0;
}

int gguInit(void)
{
	ggiInit();

	_ggu_offset=ggiRegisterExtension(sizeof(ggu_extension_t),load,unload);

	return 0;
}

int gguExit(void)
{
	ggiExit();
	return 0;
}

