/*
 * (c) 1998 Andreas Beck for The GGI project
 * 
 * This LibGII module is a very simple parser for KeyPress Events.
 *
 */

#include <gii.h>

struct keypress
{ enum mode { LABEL, CODE, SYMBOL } mode;
  int value;
};

uint32 key_check(struct gii_control *ctrl,ggi_event *event)
{}

int    key_detect(struct gii_control *ctrl,ggi_event *event)
{}

/*
 * Privatedata format is :
 * mode (0-2)  value (hex, 4 digits)
 * modes are : KeyLabel (0), Keycode (1), KeySymbol (2)
 * value is the appropriate value of the corresponding field.
 */
 
int    key_write_pvtdata(struct gii_control *ctrl,char *string,int maxlen)
{
	struct keypress *keyp=ctrl->pvtdata;

	if (maxlen<7) {
		*string='\0';return -1;
	}
	sprintf(string,"%c %4x",'0'+keyp->mode,keyp->value);

	return 0;
}

int    key_read_pvtdata(struct gii_control *ctrl,const char *string)
{
	struct keypress *keyp=ctrl->pvtdata;
	char hlp;

	sscanf(string,"%c %x",&hlp,&keyp->value);
	keyp->mode=hlp-'0';

	return 0;
}

void   key_free_pvtdata(struct gii_control *ctrl)
{
	struct keypress *keyp=ctrl->pvtdata;

	free(keyp);ctrl->pvtdata=NULL;
	
	return;
}

int    key_get_name(struct gii_control *ctrl,char *string,int maxlen)
{
	struct keypress *keyp=ctrl->pvtdata;
	char hlpstr[30];

	switch(keyp->mode)
	{ case LABEL :	sprintf(hlpstr,"L%4x",keyp->value);break;
	  case CODE  :	sprintf(hlpstr,"C%4x",keyp->value);break;
	  case SYMBOL:	sprintf(hlpstr,"S%4x",keyp->value);break;
	}
	strncpy(string,hlpstr,maxlen);
	return 0;
}


static control_ops mycontrols= {
	"Key",
	key_check,
	key_detect,
	key_write_pvtdata,
	key_read_pvtdata,
	key_free_pvtdata,
	key_get_name,
};
